unit polygone;
 
// 1 ) Pour dtection de Droites paisses d'1 seul  plusieurs pixel(s)
//     dtection par calcul tenant compte de l'paisseur du trait
//     permet d'identifier une droite parmi d'autres de mme couleur le cas chant,
//     et mme de dtecter une droite invisible  l'cran du tye limite de zone.
// 2 ) Pour dplacement de la Droite par agrippage de la droite  la souris :
//     -  moins de 15% d'une extrmit : dplacement par tirage-rotation
//     -  plus de 15% d'une extrmit  : dplacement paralllement  elle-mme
// 3) Idem pour Rectangles et rotation par agrippage  mois de 15% d'un angle.
// 4) Cercles : dplacement par aggrippage n'importe o sauf dans la zone situe
//     l'extrme droite du cercle o l'agrippage provoque la variation du rayon
// 5) Polygones rguliers non toils : Dplacement et rotation comme avec les rectangles,
//    et variation de rayon par agrippage n'importe-o combin avec la touche Maj (Shift).
 
interface
 
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, StdCtrls, Math, ComCtrls, Menus;
 
type
  TfrmImgD = class(TForm)
    Panel1: TPanel;
    Image1: TImage;
    btnFondNoir: TButton;
    btnFondBlanc: TButton;
    btnTracerRectangles: TButton;
    btnTracerCercles: TButton;
    bTracerPolygones: TButton;
    Label1: TLabel;
    labeltemoin: TLabel;
    procedure FormShow(Sender: TObject);
    procedure btnTracerDroitesClick(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnFondNoirClick(Sender: TObject);
    procedure btnFondBlancClick(Sender: TObject);
    procedure btnTracerRectanglesClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnTracerCerclesClick(Sender: TObject);
    procedure bTracerPolygonesClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;
 
var
  frmImgD: TfrmImgD;
 
implementation
 
{$R *.DFM}
 
// Droites ---------------------------------------------------------------------
 
type TDroiteA = record // Droites avec attributs
                  xo,yo,                 // coordonnes d'origine
                  xe,ye : integer;       // coordonnes d'extrmit
                  coulTrait : TColor;    // couleur du trac
                  epTrait   : Integer;   // paisseur du trac
                  stylTrait : TPenStyle; // style du trac si droite d'1 seul pixel
                end;
 
     TDroitesA = array [0..9] of TDroiteA;
 
var  MesDroitesA  : TDroitesA;
     iDroiteSelectionnee, xMp,yMp : integer;
     rOrigine    : Extended; // ratio d'loignement du point d'agripage par rapport  l'origine de la droite
     pm          : TPenMode;
 
procedure TraceDroiteA( C : tCanvas; D : TDroiteA; mode : TPenMode);
begin     with C do
          begin pen.width := D.epTrait;
                pen.color := D.coulTrait;
                pen.Style := D.stylTrait;
                pen.mode  := mode;
                moveto(D.xo, D.yo);
                lineto(D.xe, D.ye);
                pen.mode := pmCopy;
          end;
end;
 
function PointDansTronconDroiteA(xs,ys : integer; Droite : TDroiteA) : Extended;
//@param Result renvoie :
//       -1 si le point xs,ys est en-dehors de la droite
//        5 si ce point est pile celui d'une doite rduite  un point
//       et si xs,ys est situ sur le tronon de la droite, renvoie une valeur
//       comprise entre 0..1 et proportionnelle  l'loignement de ce point
//       par rapport  l'origine de la droite.
var      a, b, miEp, lg : Extended; dx,dy,yc : integer; okx,oky : boolean;
begin    Result:=-1;
         miEp:=Droite.epTrait/2;
         dx:=Droite.xe - Droite.xo;
         dy:=Droite.ye - Droite.yo;
         if (dx=0) and (dy=0) then // Droite rduite  1 seul point
         begin if (xs - miEp <=Droite.xo) and (Droite.xo <= xs + miEp)
               and (ys - miEp <=Droite.yo) and (Droite.yo <= ys + miEp)
               then Result:=5;
               EXIT;
         end;
         okx:=False; oky:=False;
         // okx et oky ne servent qu'' tester si le point-cible est situ entre
         // l'origine et l'extrmit du tronon et non sur ses prolongements
         if ((dy<0) and (ys<=Droite.yo) and (ys>=Droite.ye))
         or ((dy>0) and (ys<=Droite.ye) and (ys>=Droite.yo)) then oky:=True;
         if ((dx>0) and (xs<=Droite.xe) and (xs>=Droite.xo))
         or ((dx<0) and (xs<=Droite.xo) and (xs>=Droite.xe)) then okx:=True;
 
         if (dx=0) then // Droite verticale
         begin if (xs - miEp <=Droite.xo) and (Droite.xo <= xs + miEp)
               and oky then Result:=(ys - Droite.yo)/dy;
               EXIT;
         end else
         if (dy=0) then // Droite horizontale
         begin if (ys - miEp <=Droite.yo) and (Droite.yo <= ys + miEp)
               and okx then Result:=(xs - Droite.xo)/dx;
               EXIT;
         end else // Droite incline "y = a.x + b"
         begin a:=dy/dx; // pente
               b:=Droite.yo - a*Droite.xo;
               yc:=round(a*xs + b);     // y-calcul(xs)
               lg:=sqrt(dx*dx + dy*dy); // longueur tronon de droite
               miEp:=abs(miEp*lg/dx);   // projection de miEp sur la verticale yc-ys en xs
               if (yc + miEp >= ys) and (yc - miEp <= ys)
               and okx and oky then Result:=(xs - Droite.xo)/dx;
         end;
end;
 
// Rectangles-------------------------------------------------------------------
 
type TDroite = record // Droites sans attributs
                  xo,yo,                 // coordonnes d'origine
                  xe,ye : integer;       // coordonnes d'extrmit
                end;
 
type TRectangle = record
                     xo,yo,w,h : integer;
                     xc,yc     : integer;
                     Bords : array[1..4] of TDroite;
                     coulTrait : TColor;    // couleur du trac
                     epTrait   : Integer;   // paisseur du trac
                     stylTrait : TPenStyle; // style du trac si droite d'1 seul pixel
                  end;
 
     TRectangles = array of TRectangle;
 
var  MesRectangles   : TRectangles;
     iRectSelectionne,
     iBord : integer;
 
function CreeRect( ixo,iyo,iw,ih : integer; icoulTrait : TColor;
                   iepTrait : byte; istylTrait : TPenStyle) : TRectangle;
begin    with Result do
         begin xo:=ixo; yo:=iyo; w:=iw; h:=ih; coulTrait:=icoulTrait;
               epTrait:=iepTrait; stylTrait:=istylTrait;
               // 1 = bord gauche
               Bords[1].xo:=xo; Bords[1].yo:=yo;
               Bords[1].xe:=xo; Bords[1].ye:=yo+h;
               // 2 = bord inf
               Bords[2].xo:=xo;   Bords[2].yo:=yo+h;
               Bords[2].xe:=xo+w; Bords[2].ye:=yo+h;
               // 3 = bord droite
               Bords[3].xo:=xo+w; Bords[3].yo:=yo+h;
               Bords[3].xe:=xo+w; Bords[3].ye:=yo;
               // 4 = bord sup
               Bords[4].xo:=xo+w; Bords[4].yo:=yo;
               Bords[4].xe:=xo;   Bords[4].ye:=yo;
               xc:=xo + (w div 2);
               yc:=yo + (h div 2);
         end;
end;
 
procedure TraceRect(C : tCanvas; Rectangle : TRectangle; mode : TPenMode);
var       i : integer; al : Extended; D : TDroite;
begin     with C.pen do
          begin color := Rectangle.coulTrait;
                Style := Rectangle.stylTrait;
                width := Rectangle.epTrait;
          end;
          for i:=1 to 4 do
          begin D:=Rectangle.Bords[i];
                with C do
                begin pen.mode  := mode;
                      moveto(D.xo, D.yo); lineto(D.xe, D.ye);
                      moveto(D.xo, D.yo); lineto(D.xo, D.yo);
                end;
          end;
          with Rectangle do
          begin al:=arcTan2(Bords[1].yo - Bords[4].yo, Bords[4].xo - Bords[1].xo);
                frmImgD.label1.caption:='al='+FloatToStr(round(al*180/Pi));
          end;
end;
 
procedure TraceRectBis(C : tCanvas; Rectangle : TRectangle; mode : TPenMode);
//        Rectangle ddoubl
var       et,etcos,etsin : integer; al : Extended; p14,p12,p23,p34 : TPoint;
begin     with Rectangle do
          begin p14.x:=Bords[1].xo; p14.y:=Bords[1].yo;
                p12.x:=Bords[2].xo; p12.y:=Bords[2].yo;
                p23.x:=Bords[3].xo; p23.y:=Bords[3].yo;
                p34.x:=Bords[4].xo; p34.y:=Bords[4].yo;
                C.pen.color := coulTrait;
                C.pen.Style := stylTrait;
                C.pen.mode  := mode;
                et:=epTrait;
                al:=arcTan2(p14.y-p34.y, p34.x-p14.x);
                frmImgD.label1.caption:='al='+FloatToStr(round(al*180/Pi));
          end;
          with C do
          begin pen.width := 1;
                pen.mode  := mode;
                moveTo(p14.x,p14.y); lineTo(p12.x,p12.y);
                lineTo(p23.x,p23.y); lineTo(p34.x,p34.y); lineTo(p14.x,p14.y);
                
                etcos:=round(et*cos(al)); etsin:=round(et*sin(al));
 
                p14.x:=p14.x + etcos + etsin;    
                p14.y:=p14.y + etcos - etsin;
 
                p12.x:=p12.x + etcos - etsin;
                p12.y:=p12.y - etcos - etsin;
 
                p23.x:=p23.x - etcos - etsin;
                p23.y:=p23.y - etcos + etsin;
 
                p34.x:=p34.x - etcos + etsin;
                p34.y:=p34.y + etcos + etsin;
 
                moveTo(p14.x,p14.y); lineTo(p12.x,p12.y);
                lineTo(p23.x,p23.y); lineTo(p34.x,p34.y); lineTo(p14.x,p14.y);
          end;
end;
 
function PointDansTronconDroite(xs,ys : integer; Droite : TDroite; epDroite : byte) : Extended;
//@param Result renvoie :
//       -1 si le point xs,ys est en-dehors de la droite
//        5 si ce point est pile celui d'une doite rduite  un point
//       et si xs,ys est situ sur le tronon de la droite, renvoie une valeur
//       comprise entre 0..1 et proportionnelle  l'loignement de ce point
//       par rapport  l'origine de la droite.
var      a, b, miEp, lg : Extended; dx,dy,yc : integer; okx,oky : boolean;
begin    Result:=-1;
         miEp:=epDroite/2;
         dx:=Droite.xe - Droite.xo;
         dy:=Droite.ye - Droite.yo;
         if (dx=0) and (dy=0) then // Droite rduite  1 seul point
         begin if (xs - miEp <=Droite.xo) and (Droite.xo <= xs + miEp)
               and (ys - miEp <=Droite.yo) and (Droite.yo <= ys + miEp)
               then Result:=5;
               EXIT;
         end;
         okx:=False; oky:=False;
         // okx et oky ne servent qu'' tester si le point-cible est situ entre
         // l'origine et l'extrmit du tronon et non sur ses prolongements
         if ((dy<0) and (ys<=Droite.yo) and (ys>=Droite.ye))
         or ((dy>0) and (ys<=Droite.ye) and (ys>=Droite.yo)) then oky:=True;
         if ((dx>0) and (xs<=Droite.xe) and (xs>=Droite.xo))
         or ((dx<0) and (xs<=Droite.xo) and (xs>=Droite.xe)) then okx:=True;
 
         if (dx=0) then // Droite verticale
         begin if (xs - miEp <=Droite.xo) and (Droite.xo <= xs + miEp)
               and oky then Result:=(ys - Droite.yo)/dy;
               EXIT;
         end else
         if (dy=0) then // Droite horizontale
         begin if (ys - miEp <=Droite.yo) and (Droite.yo <= ys + miEp)
               and okx then Result:=(xs - Droite.xo)/dx;
               EXIT;
         end else // Droite incline "y = a.x + b"
         begin a:=dy/dx; // pente
               b:=Droite.yo - a*Droite.xo;
               yc:=round(a*xs + b);     // y-calcul(xs)
               lg:=sqrt(dx*dx + dy*dy); // longueur tronon de droite
               miEp:=abs(miEp*lg/dx);   // projection de miEp sur la verticale yc-ys en xs
               if (yc + miEp >= ys) and (yc - miEp <= ys)
               and okx and oky then Result:=(xs - Droite.xo)/dx;
         end;
end;
 
function PointSurBordRect(xs,ys : integer; Rectangle : TRectangle) : Extended;
var      i : byte;
begin    i:=0;
         repeat inc(i);
                Result:=PointDansTronconDroite(xs,ys, Rectangle.Bords[i], Rectangle.epTrait);
                iBord:=i;
         until (Result>=0) or (i=4);
end;
 
function  DistancePtDroite(xp,yp : integer; D : TDroite) : Extended;
var       al, a, b : Extended;
begin     with D do
          begin if xo=xe then Result:=xp-xo // D verticale
                else if yo=ye then Result:=yp-yo // D horizontale
                else begin // D incline
                     al:=arcTan2(ye - yo, xo - xe);
                     a:=(ye - yo)/(xe - xo);
                     b:=yo - a*xo;
                     Result:=(yp - a*xp - b)*cos(al);
                end;
          end;
end;
 
procedure TranslatRect(var Rectangle : TRectangle; dx,dy : integer);
var       j : byte;
begin     with Rectangle do
          begin for j:=1 to 4 do
                begin Bords[j].xo:=Bords[j].xo+dx;
                      Bords[j].yo:=Bords[j].yo+dy;
                      Bords[j].xe:=Bords[j].xe+dx;
                      Bords[j].ye:=Bords[j].ye+dy;
                end;
                xc:=xc+dx; yc:=yc+dy;
          end;
end;
 
procedure EtireRect(var Rectangle : TRectangle; xs,ys, Bord : integer);
var       dx,dy : integer; al,d : Extended;
 
          procedure DecaleBord(j : byte);
          begin     with Rectangle do
                    begin Bords[j].xo:=Bords[j].xo+dx;
                          Bords[j].yo:=Bords[j].yo+dy;
                          Bords[j].xe:=Bords[j].xe+dx;
                          Bords[j].ye:=Bords[j].ye+dy;
                    end;
          end;
 
          procedure DecaleExtrem;
          begin     with Rectangle do
                    begin case Bord of
                      1 : begin Bords[2].xo:=Bords[2].xo+dx; Bords[2].yo:=Bords[2].yo+dy;
                                Bords[4].xe:=Bords[4].xe+dx; Bords[4].ye:=Bords[4].ye+dy; end;
                      2 : begin Bords[3].xo:=Bords[3].xo+dx; Bords[3].yo:=Bords[3].yo+dy;
                                Bords[1].xe:=Bords[1].xe+dx; Bords[1].ye:=Bords[1].ye+dy; end;
                      3 : begin Bords[4].xo:=Bords[4].xo+dx; Bords[4].yo:=Bords[4].yo+dy;
                                Bords[2].xe:=Bords[2].xe+dx; Bords[2].ye:=Bords[2].ye+dy; end;
                      4 : begin Bords[1].xo:=Bords[1].xo+dx; Bords[1].yo:=Bords[1].yo+dy;
                                Bords[3].xe:=Bords[3].xe+dx; Bords[3].ye:=Bords[3].ye+dy; end;
                      end;
                    end;
          end;
 
begin     with Rectangle do
          begin if Bords[Bord].xo - Bords[Bord].xe = 0  // bord vertical
                then begin dx:=xs - Bords[Bord].xo; dy:=0; end
                else begin
                       d:=DistancePtDroite(xs,ys, Bords[Bord]);
                       al:=arcTan2(Bords[Bord].ye - Bords[Bord].yo, Bords[Bord].xo - Bords[Bord].xe);
                       dy:=round(d*cos(al));
                       dx:=round(d*sin(al));
                end;
                DecaleBord(Bord); DecaleExtrem;
                xc:=Bords[1].xo + ((Bords[2].xe - Bords[1].xo) div 2);
                yc:=Bords[1].yo + ((Bords[2].ye - Bords[1].yo) div 2);
                xo:=Bords[1].xo; yo:=Bords[1].yo;
                w:=round(sqrt(sqr(Bords[2].xe - Bords[2].xo) + sqr(Bords[2].ye - Bords[2].yo)));
                h:=round(sqrt(sqr(Bords[1].xe - Bords[1].xo) + sqr(Bords[1].ye - Bords[1].yo)));
          end;
end;
 
procedure RotatRect(var Rectangle : TRectangle; xs,ys : integer);
var       al,be,R : Extended;
begin     with Rectangle do
          begin R:= sqrt(w*w + h*h)/2;
                al:=ArcTan2(yc - ys, xs - xc);
                be:=al - ArcTan(h/w);
                Bords[4].xo:=xc + round(R*cos(al));
                Bords[4].yo:=yc - round(R*sin(al));
                Bords[4].xe:=Bords[4].xo - trunc(w*cos(be));
                Bords[4].ye:=Bords[4].yo + trunc(w*sin(be));
 
                Bords[1].xo:=Bords[4].xe;
                Bords[1].yo:=Bords[4].ye;
                xo:=Bords[1].xo;
                yo:=Bords[1].yo;
                Bords[1].xe:=Bords[1].xo + trunc(h*sin(be));
                Bords[1].ye:=Bords[1].yo + trunc(h*cos(be));
 
                Bords[2].xo:=Bords[1].xe;
                Bords[2].yo:=Bords[1].ye;
                Bords[2].xe:=Bords[2].xo + trunc(w*cos(be));
                Bords[2].ye:=Bords[2].yo - trunc(w*sin(be));
 
                Bords[3].xo:=Bords[2].xe;
                Bords[3].yo:=Bords[2].ye;
                Bords[3].xe:=Bords[3].xo - trunc(h*sin(be));
                Bords[3].ye:=Bords[3].yo - trunc(h*cos(be));
          end;
end; // RotatRect
 
// Cercles ---------------------------------------------------------------------
 
type TCercle = record
                     xc,yc,R   : integer;
                     coulTrait : TColor;
                     epTrait   : Integer;
                     stylTrait : TPenStyle;
                  end;
 
     TCercles = array of TCercle;
 
var  MesCercles : TCercles;
     iCercleSelectionne : integer;
 
function CreeCercle( ixc,iyc,iR: integer; iCoulTrait : TColor;
                     iEpTrait : byte; iStylTrait : TPenStyle) : TCercle;
begin    with Result do
         begin xc:=ixc; yc:=iyc; R:=iR;
               coulTrait:=iCoulTrait; epTrait:=iEpTrait; stylTrait:=iStylTrait;
         end;
end;
 
procedure TraceCercle( C : tCanvas; Cercle : TCercle; mode : TPenMode);
var       Re : TRect;
begin     with C do
          begin pen.width := Cercle.epTrait;
                pen.color := Cercle.coulTrait;
                pen.Style := Cercle.stylTrait;
                pen.mode  := mode;
                Re:=Rect( Cercle.xc-Cercle.R, Cercle.yc-Cercle.R,
                          Cercle.xc+Cercle.R, Cercle.yc+Cercle.R);
                C.Ellipse(Re);
          end;
end;
 
function PointSurCercle(xs,ys : integer; Cercle : TCercle) : Extended;
//@param Result : sera compris entre -Pi et +Pi radians si le point xs,ys est sur le cercle
//       et - 5 radians si le point est ailleurs.
var      d : Extended;
begin    Result:=-5;
         with Cercle do
         begin d:=sqrt((xs-xc)*(xs-xc) + (ys-yc)*(ys-yc));
               if (d >= R - (epTrait/2)) and (d <= R + (epTrait/2)) then
               begin if xs = xc then Result:=Pi/2
                     else Result:=arcTan2(ys-yc, xs-xc);
               end;
         end;
end;
 
procedure TranslatCercle(var Cercle : TCercle; dx,dy : integer);
begin     with Cercle do begin xc:=xc+dx; yc:=yc+dy; end;
end;
 
// Polygones rguliers non toils ---------------------------------------------
// triangles, carrs, pentagones, etc
 
type TPolygone = record
                     nbCotes,             // nb de cts >=3
                     xc,yc,R   : integer; // posit du centre et rayon
                     incli     : Extended;// inclinaison en rotation en radians
                     Bords : array of TDroite;
                     coulTrait : TColor;    // couleur du trac
                     epTrait   : Integer;   // paisseur du trac
                     stylTrait : TPenStyle; // style du trac si droite d'1 seul pixel
                  end;
 
     TPolygones = array of TPolygone;
 
var  MesPolygones   : TPolygones;
     iPolygoneSelectionne : integer;
 
function CreePolygone( inbCotes,ixc,iyc,iR : integer; eIncli : Extended;
                       icoulTrait : TColor; iepTrait : byte; istylTrait : TPenStyle) : TPolygone;
var      i : byte; Theta : Extended; xs,ys : integer;
begin    if inbCotes<=2 then inbCotes:=3;
         with Result do
         begin nbCotes:=inbCotes; xc:=ixc; yc:=iyc; R:=iR; coulTrait:=icoulTrait;
               epTrait:=iepTrait; stylTrait:=istylTrait;
               Incli:=eIncli;
               SetLength(Bords, nbCotes+1);
               for i:=1 to nbCotes do
               begin Theta:=eIncli + ((i-1)*2*Pi/nbCotes);
                     xs:=xc+round(R*cos(Theta));
                     ys:=yc+round(R*sin(Theta));
                     Bords[i].xo:=xs;
                     Bords[i].yo:=ys;
               end;
               for i:=1 to nbCotes do
               begin if i<=nbCotes-1 then
                     begin Bords[i].xe:=Bords[i+1].xo;
                           Bords[i].ye:=Bords[i+1].yo;
                     end else
                     begin Bords[i].xe:=Bords[1].xo;
                           Bords[i].ye:=Bords[1].yo;
                     end;
               end;
         end;
end;
 
procedure TracePolygone(C : tCanvas; Polygone : TPolygone; mode : TPenMode);
var       i : integer; D : TDroite;
begin     with C do
          begin pen.mode  := mode;
                pen.color := Polygone.coulTrait;
                pen.Style := Polygone.stylTrait;
                pen.width := Polygone.epTrait;
                for i:=1 to Polygone.nbCotes do
                begin D:=Polygone.Bords[i];
                      moveto(D.xo, D.yo); lineto(D.xe, D.ye);
                      moveto(D.xo, D.yo); lineto(D.xo, D.yo);
                end;
          end;
end;
 
function PointSurBordPolygone(xs,ys : integer; Polygone : TPolygone) : Extended;
var      i : integer;
begin    i:=0;
         repeat inc(i);
                Result:=PointDansTronconDroite(xs,ys, Polygone.Bords[i], Polygone.epTrait);
                iBord:=i;
         until (Result>=0) or (i=Polygone.nbCotes);
end;
 
procedure TranslatPolygone(var Polygone : TPolygone; dx,dy : integer);
var       i : integer;
begin     with Polygone do
          begin for i:=1 to Polygone.nbCotes do
                begin Bords[i].xo:=Bords[i].xo+dx;
                      Bords[i].yo:=Bords[i].yo+dy;
                      Bords[i].xe:=Bords[i].xe+dx;
                      Bords[i].ye:=Bords[i].ye+dy;
                end;
                xc:=xc+dx; yc:=yc+dy;
          end;
end;
 
procedure RotatPolygone(var Polygone : TPolygone; X,Y,dx,dy : integer);
var       i : integer; xp,yp,xs,ys : integer; Theta,ThetaX,ThetaP, dTheta : Extended;
begin     xp:=X + dx; yp:=Y + dy;
          with Polygone do
          begin ThetaX:=arctan2(yc - Y, X - xc); ThetaP:=arctan2(yc - yp, xp - xc);
                dTheta:=ThetaX - ThetaP;
                Incli:=Incli + dTheta;
                for i:=1 to nbCotes do
                begin Theta:=Incli + ((i-1)*2*Pi/nbCotes);
                      xs:=xc+round(R*cos(Theta));
                      ys:=yc+round(R*sin(Theta));
                      Bords[i].xo:=xs;
                      Bords[i].yo:=ys;
                end;
                for i:=1 to nbCotes do
                begin if i<=nbCotes-1 then
                      begin Bords[i].xe:=Bords[i+1].xo;
                            Bords[i].ye:=Bords[i+1].yo;
                      end else
                      begin Bords[i].xe:=Bords[1].xo;
                            Bords[i].ye:=Bords[1].yo;
                      end;
                end;
         end;
end;
 
procedure DimPolygone(var Polygone : TPolygone; iR : integer);
var       i : integer; xs,ys : integer; Theta : Extended;
begin     with Polygone do
          begin R:=iR;
                for i:=1 to nbCotes do
                begin Theta:=Incli + ((i-1)*2*Pi/nbCotes);
                      xs:=xc+round(R*cos(Theta));
                      ys:=yc+round(R*sin(Theta));
                      Bords[i].xo:=xs;
                      Bords[i].yo:=ys;
                end;
                for i:=1 to nbCotes do
                begin if i<=nbCotes-1 then
                      begin Bords[i].xe:=Bords[i+1].xo;
                            Bords[i].ye:=Bords[i+1].yo;
                      end else
                      begin Bords[i].xe:=Bords[1].xo;
                            Bords[i].ye:=Bords[1].yo;
                      end;
                end;
         end;
end;
 
// Utilisation -----------------------------------------------------------------

procedure TfrmImgD.FormShow(Sender: TObject);
var       ep : byte;
begin     //color:=clWhite; //<pour tracs avec pmNotXor sur canvas Form
          iDroiteSelectionnee:=-1;
          pm:=pmNotXor;
          // 1) srie de droites fines
          ep:=1; // un seul pixel
          with MesDroitesA[0] do
          begin xo:=50; yo:=50; xe:=200; ye:=100;
                coulTrait:=clRed; epTrait:=ep; stylTrait:=psSolid;
          end;
          with MesDroitesA[1] do // parallle  la prcdente et en contact avec celle-ci
          begin xo:=50; yo:=51; xe:=200; ye:=101;
                coulTrait:=clLime; epTrait:=ep; stylTrait:=psDash;
          end;
          with MesDroitesA[2] do
          begin xo:=50; yo:=100; xe:=200; ye:=50;
                coulTrait:=clNavy; epTrait:=ep; stylTrait:=psDot;
          end;
          with MesDroitesA[3] do // verticale
          begin xo:=100; yo:=110; xe:=100; ye:=150;
                coulTrait:=clGreen; epTrait:=ep; stylTrait:=psDashDot;
          end;
          with MesDroitesA[4] do // horizontale
          begin xo:=100; yo:=110; xe:=50; ye:=110;
                coulTrait:=clYellow; epTrait:=ep; stylTrait:=psDashDotDot;
          end; 
          // 2) srie de droites paisses
          ep:=10; // 10 pixels
          with MesDroitesA[5] do
          begin xo:=50; yo:=150; xe:=200; ye:=200;
                coulTrait:=clRed; epTrait:=ep; stylTrait:=psSolid;
          end;
          with MesDroitesA[6] do // parallle  la prcdente et en contact avec celle-ci
          begin xo:=50; yo:=161; xe:=200; ye:=211;
                coulTrait:=clLime; epTrait:=ep; stylTrait:=psSolid;
          end;
          with MesDroitesA[7] do
          begin xo:=50; yo:=200; xe:=200; ye:=150;
                coulTrait:=clNavy; epTrait:=ep; stylTrait:=psSolid;
          end;
          with MesDroitesA[8] do // verticale
          begin xo:=100; yo:=210; xe:=100; ye:=250;
                coulTrait:=clGreen; epTrait:=ep; stylTrait:=psSolid;
          end;
          with MesDroitesA[9] do // horizontale
          begin xo:=100; yo:=210; xe:=50; ye:=210;
                coulTrait:=clYellow; epTrait:=ep; stylTrait:=psSolid;
          end;
          // 3) Rectangles
          iRectSelectionne:=-1;
          SetLength(MesRectangles,2);
          MesRectangles[0]:=CreeRect( 250,50,100,30, clNavy, 10, psSolid);
          MesRectangles[1]:=CreeRect( 250,100,100,30, clGreen, 8, psSolid);
          // 4) Cercles
          iCercleSelectionne:=-1;
          SetLength(MesCercles,2);
          MesCercles[0]:=CreeCercle( 250,250,40, clRed, 5, psSolid);
          MesCercles[1]:=CreeCercle( 350,250,40, clFuchsia, 2, psSolid);
          // 3) Polygones
          iPolygoneSelectionne:=-1;
          SetLength(MesPolygones,5);
          MesPolygones[0]:=CreePolygone( 3,150,350,30, 0, clRed,  4 , psSolid);
          MesPolygones[1]:=CreePolygone( 4,250,350,30, 0, clLime, 4 , psSolid);
          MesPolygones[2]:=CreePolygone( 5,350,350,30, 0, clBlue, 4 , psSolid);
          MesPolygones[3]:=CreePolygone( 6,450,350,30, 0, clNavy, 4 , psSolid);
          MesPolygones[4]:=CreePolygone( 7,550,350,30, 0, clFuchsia, 4 , psSolid);
          WindowState:=wsMaximized;
end;
 
procedure TfrmImgD.btnTracerDroitesClick(Sender: TObject);
var       i : integer;
begin     for i:=Low(MesDroitesA) to High(MesDroitesA)
          do TraceDroiteA(Image1.Canvas, MesDroitesA[i], pm);
end;
 
procedure TfrmImgD.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var       i : integer;
begin     labelTemoin.color:=clBtnFace;
          labelTemoin.caption:=FloatToStr(rOrigine);
          //1 ) Tests sur droites
          i:=-1; iDroiteSelectionnee:=-1;
          repeat inc(i); rOrigine:=PointDansTronconDroiteA(X,Y, MesDroitesA[i])
          until (rOrigine>=0) or (i=High(MesDroitesA));
          // ici on quitte la boucle ds qu'on a dtect le trac sur lequel on a cliqu
          if rOrigine>=0
          then begin labelTemoin.caption:=FloatToStr(rOrigine);
                     labelTemoin.color:=MesDroitesA[i].coulTrait;
                     iDroiteSelectionnee:=i;
                     Screen.Cursor := crHandPoint;
                     xMp:=X; yMp:=Y;  EXIT;
          end;
          //2 ) Tests sur rectangles
          i:=-1; iRectSelectionne:=-1;
          repeat inc(i); rOrigine:=PointSurBordRect(X,Y, MesRectangles[i]);
          until (rOrigine>=0) or (i=High(MesRectangles));
          if rOrigine>=0
          then begin labelTemoin.caption:=FloatToStr(rOrigine);
                     labelTemoin.color:=MesRectangles[i].coulTrait;
                     iRectSelectionne:=i;
                     Screen.Cursor := crHandPoint;
                     xMp:=X; yMp:=Y; EXIT;
          end;
          //3) Tests sur Cercles
          i:=-1; iCercleSelectionne:=-1;
          repeat inc(i); rOrigine:=PointSurCercle(X,Y, MesCercles[i]);
          until (rOrigine<>-5) or (i=High(MesCercles));
          if rOrigine<>-5
          then begin labelTemoin.caption:=intToStr(trunc(rOrigine*180/Pi))+'';
                     labelTemoin.color:=MesCercles[i].coulTrait;
                     iCercleSelectionne:=i;
                     Screen.Cursor := crHandPoint;
                     xMp:=X; yMp:=Y; EXIT;
          end;
          //3) Tests sur Polygones
          i:=-1; iPolygoneSelectionne:=-1;
          repeat inc(i); rOrigine:=PointSurBordPolygone(X,Y, MesPolygones[i]);
          until (rOrigine>=0) or (i=High(MesPolygones));
          if rOrigine>=0
          then begin labelTemoin.caption:=intToStr(trunc(rOrigine*180/Pi))+'';
                     labelTemoin.color:=MesPolygones[i].coulTrait;
                     iPolygoneSelectionne:=i;
                     Screen.Cursor := crHandPoint;
                     xMp:=X; yMp:=Y; EXIT;
          end;
end;
 
procedure TfrmImgD.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,Y: Integer);
var       i,dxs,dys : integer;
begin     //1) Droites
          i:=iDroiteSelectionnee;
          if i>=0 then
          begin dxs:=X - xMp; dys:=Y - yMp;
                with MesDroitesA[i] do
                begin TraceDroiteA(Image1.Canvas, MesDroitesA[i], pm);
                      if rOrigine<=0.15 then // Etirage droite par agrippage prs de l''origine
                      begin xo:=xo+dxs; yo:=yo+dys; end else
                      if rOrigine>=0.85 then // Etirage droite par agrippage prs de l''extrmit
                      begin xe:=xe+dxs; ye:=ye+dys; end
                      else // Dplacement droite parallle  elle-mme
                      begin xo:=xo+dxs; yo:=yo+dys; xe:=xe+dxs; ye:=ye+dys; end;
                      TraceDroiteA(Image1.Canvas, MesDroitesA[i], pm);
                end;
                xMp:=X; yMp:=Y;
          end;
          //2) Rectangles
          i:=iRectSelectionne;
          if i>=0 then
          begin dxs:=X - xMp; dys:=Y - yMp;
                if not odd(i)
                then TraceRect(Image1.Canvas, MesRectangles[i], pm)
                else TraceRectBis(Image1.Canvas, MesRectangles[i], pm);
 
                if (rOrigine<=0.15) or (rOrigine>=0.85)
                then RotatRect(MesRectangles[i], X, Y) else
                begin case iBord of
                        4 : TranslatRect(MesRectangles[i], dxs, dys); // Dplacement parallle  lui-mme
                        else EtireRect(MesRectangles[i], X, Y, iBord);
                      end;
                end;
 
                if not odd(i)
                then TraceRect(Image1.Canvas, MesRectangles[i], pm)
                else TraceRectBis(Image1.Canvas, MesRectangles[i], pm);
                xMp:=X; yMp:=Y;
          end;
          //3) Cercles
          i:=iCercleSelectionne;
          if i>=0 then
          begin dxs:=X - xMp; dys:=Y - yMp;
                TraceCercle(Image1.Canvas, MesCercles[i], pm);
                if (rOrigine>=-0.15) and (rOrigine<=0.15)
                then MesCercles[i].R:=MesCercles[i].R+dxs    // variation Rayon
                else TranslatCercle(MesCercles[i], dxs,dys); // translation
                TraceCercle(Image1.Canvas, MesCercles[i], pm);
                xMp:=X; yMp:=Y;
          end;
          //4) Polygones
          i:=iPolygoneSelectionne;
          if i>=0 then
          begin dxs:=X - xMp; dys:=Y - yMp;
                TracePolygone(Image1.Canvas, MesPolygones[i], pm);
                if ssShift in Shift
                then DimPolygone(MesPolygones[i], MesPolygones[i].R + dxs) // variation Rayon
                else
                if (rOrigine>0.15) and (rOrigine<0.85)
                then TranslatPolygone(MesPolygones[i], dxs,dys)   // translation
                else RotatPolygone(MesPolygones[i], X,Y, dxs,dys);// rotation
                TracePolygone(Image1.Canvas, MesPolygones[i], pm);
                xMp:=X; yMp:=Y;
          end;
end;
 
procedure TfrmImgD.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin     iDroiteSelectionnee:=-1;
          iRectSelectionne:=-1;
          iCercleSelectionne:=-1;
          iPolygoneSelectionne:=-1;
          Screen.Cursor := crDefault;
end;
 
procedure TfrmImgD.btnFondNoirClick(Sender: TObject);
begin     with Image1.Canvas do
          begin brush.color:=clBlack;
                FillRect(Rect(0,0,image1.width,image1.height));
          end;
end;

procedure TfrmImgD.btnFondBlancClick(Sender: TObject);
begin     with Image1.Canvas do //< superflu si Image1 est vide
          begin brush.color:=clWhite;
                FillRect(Rect(0,0,image1.width,image1.height));
          end;
end;
 
procedure TfrmImgD.btnTracerRectanglesClick(Sender: TObject);
var       i : integer;
begin
for i:=Low(MesRectangles) to High(MesRectangles)
           do if not odd(i)
              then TraceRect(Image1.Canvas, MesRectangles[i], pm)
              else TraceRectBis(Image1.Canvas, MesRectangles[i], pm);
end;
 
procedure TfrmImgD.FormResize(Sender: TObject);
begin     image1.left:=120;
          image1.width:=clientWidth-image1.left;
          image1.height:=clientHeight;
end;
 
procedure TfrmImgD.btnTracerCerclesClick(Sender: TObject);
var       i : integer;
begin     for i:=Low(MesCercles) to High(MesCercles)
          do TraceCercle(Image1.Canvas, MesCercles[i], pm);
end;
 
procedure TfrmImgD.bTracerPolygonesClick(Sender: TObject);
var       i : integer;
begin
  for i:=Low(MesPolygones) to High(MesPolygones)
           do TracePolygone(Image1.Canvas, MesPolygones[i], pm);
end;

end.

